# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np
import os, time

#-------------------------------------------------------------------------------------------
#	this scripts detects all new FITS files written to the specified folder
#	it computes their
#	- min, mean and max values
#-------------------------------------------------------------------------------------------

#path information
path_to_watch = u"C:\\images\\"

#-------------------------------------------------------------------------------------------

#loop to detect new fits files created in folder
before = dict ([(f, None) for f in os.listdir (path_to_watch)]) 
while 1: 
	time.sleep (10) 
	after = dict ([(f, None) for f in os.listdir (path_to_watch)]) 
	added = [f for f in after if not f in before] 
	#if added: print "Added: ", ", ".join (added) 	
	before = after 

	for f in added:
		if astro.check_extension(f):
			#loading new images
			images = astro.get_imagedata([path_to_watch+f])

			#calculating statistics
			mean = np.mean(images.flatten())
			maxi = np.max(images.flatten())
			mini = np.min(images.flatten())

			print  "                   min: ", mini, "     max: ", maxi, "     mean: ", mean