# -*- coding: iso_8859_1 -*-

from astropython import cdr
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

#--- input files ---
Folder = u"C:\\Mesures\\"
Filelist = ["File_1.txt", \
			"File_2.txt", \
			"File_3.txt"]
			
Filelist = [Folder + x for x in Filelist]

#fit parameters
T0 = 2455700
period = 0.429

#------------------------------------------------------------------------------------
#	loading data
#------------------------------------------------------------------------------------

alldata = cdr.load_magdata(Filelist, light_correction = [True,Folder+'dist.dat'], plotdata = [True,'Measurements (Sept. 2011)'])

#------------------------------------------------------------------------------------
#	fitting data
#------------------------------------------------------------------------------------

popt, pcov = cdr.fit_CDR(alldata, period, T0, nb_harmo = 6, show_results = True, show_plot = True)
plt.ylim([-0.251,0.251])
plt.title('Lightcurve with its Fourier fit')
plt.show()

#------------------------------------------------------------------------------------
#	generating phase ephemerid
#------------------------------------------------------------------------------------

if False:

	JJ = np.linspace(2455822.5, 2455842.5, 241)
	print
	print "------ phase ephemerids ------"	
	phase = (JJ-T0)/popt[0]-np.floor((JJ-T0)/popt[0])

	for i,dd in enumerate(JJ):
		print dd, phase[i]

raw_input("Press Enter")
