# -*- coding: iso_8859_1 -*-

from astropython import cdr
import numpy as np
import matplotlib.pyplot as plt

#------------------------------------------------------------------------------------
#	input parameters
#------------------------------------------------------------------------------------

#--- input files ---
Folder = u"C:\\Mesures\\"
Filelist = ["File_1.txt", \
			"File_2.txt", \
			"File_3.txt"]
			
Filelist = [Folder + x for x in Filelist]

#fit parameters
T0 = 2455700
periods = np.linspace(0.2, 1.0, 10000)		#possible periods, in days

#------------------------------------------------------------------------------------
#	loading data
#------------------------------------------------------------------------------------

alldata = cdr.load_magdata(Filelist, light_correction = [True,Folder+'dist.dat'], plotdata = [True,'Measurements'])

#------------------------------------------------------------------------------------
#	searching period
#------------------------------------------------------------------------------------

error = []

for period in list(periods):
	error.append(cdr.fit_givenperiod(alldata, period, T0, nb_harmo = 6))

plt.figure()
plt.plot(periods, np.sqrt(error))
plt.grid()
plt.xlabel("Period in days")
plt.ylabel("Fit error")
plt.title("Search for rotation period")
plt.show()
raw_input("Press Enter")
