# -*- coding: iso_8859_1 -*-
"""
Main module of AstroPython library
for FITS image processing, star and asteroid photometry
Version 1.1.0 (November 2011)
Developped and maintained by Jerome CARON
Contact = jerome_caron_astro@ymail.com
"""

#--- all necessary modules --
#import numpy as np
#from scipy.optimize import leastsq
#import time, warnings, os, datetime, sys, math
#import matplotlib.pyplot as plt
#from matplotlib import cm
#from ctypes import *
#import pyfits
#import win32con
#import scipy.fftpack as fft
#import astropython.conf as conf

from astro_folder.load import get_imagedata, get_someimagedata, get_headers, get_headervalues, check_extension
#def get_imagedata(Imagelist, text_display=True):
#def get_someimagedata(Imagelist, area, text_display=True):
#def get_headers(Imagelist, text_display=True):
#def get_headervalues(Imagelist, Header):
#def check_extension(file_name):

from astro_folder.displaying import display, select
#def display(data, title=''):
#def select(fig, ax, nb, color='none'):

from astro_folder.headers import create_headers, julian_day
#def create_headers(Config, Imagelist):
#def julian_day(dateobs):

from astro_folder.save import save_imagelist
#def save_imagelist(images, headers, Imagelist):

#--------------------------------------------------------------------------
from astro_folder.combine import add_sigma_clipping, add_mean, add_median, add_median2
#def add_sigma_clipping(images, sigma_coef, iterations):
#def add_mean(images):
#def add_median(images, cutsize=[1000,1000]):
#def add_median2(images):

from astro_folder.transform import translate_Bspline, rotate_Bspline, scale_Bspline, translate_bilinear, rotate_bilinear, scale_bilinear
#def translate_Bspline(images, shift, spline_degree):
#def rotate_Bspline(images, xy_axis, angle, spline_degree):
#def scale_Bspline(images, xy_center, scaling, spline_degree):
#def translate_bilinear(images, shift):
#def rotate_bilinear(images, xy_axis, angle):
#def scale_bilinear(images, xy_center, scaling):

from astro_folder.transform2 import mirror_x, mirror_y, rot_90, rot_180, rot_270
#def mirror_x(images):
#def mirror_y(images):
#def rot_90(images):
#def rot_180(images):
#def rot_270(images):

#--------------------------------------------------------------------------
from astro_folder.process import fit_gauss_circular, fit_gauss_elliptical, fit_moffat_circular, fit_moffat_elliptical
#def fit_gauss_circular(xy, data):
#def fit_gauss_elliptical(xy, data):
#def fit_moffat_circular(xy, data):
#def fit_moffat_elliptical(xy, data):

from astro_folder.process2 import find_threshold, find_stars, find_stars_and_more, find_shift_stars_matching, find_shift_crosscorrelation
#def find_threshold(image0, detection_area, nb_stars, excluded=[], included=[]):
#def find_stars(image0, threshold, detection_area, excluded=[], included=[]):
#def find_stars_and_more(image0, threshold, detection_area, excluded=[], included=[], full_info=False):
#def find_shift_stars_matching(image1, image2, threshold, detection_area, excluded=[], included=[], text_display=False):
#def find_shift_crosscorrelation(image1, image2):

from astro_folder.process3 import find_shift_by_triangles
#def find_shift_by_triangles(image1, image2, threshold, detection_area, excluded=[], included=[], text_display=False):

from astro_folder.stats import get_median, mean_psf
#def get_median(images):
#def mean_psf(image, threshold, detection_area):

from astro_folder.calc import air_mass, hours_to_decdegrees, degrees_to_decdegrees
#def air_mass(alpha, delta, lat, long, JJ):
#def hours_to_decdegrees(hours):
#def degrees_to_decdegrees(degrees):

#--------------------------------------------------------------------------
from astro_folder.win32api import set_focus, maximize_window, scroll_up_window, get_window_size, get_window_position, move_window, resize_window, get_screen_size, close_window
#def set_focus(title):
#def maximize_window(title):
#def scroll_up_window(title):
#def close_window(title):
#def get_window_size(title):
#def get_window_position(title):
#def move_window(title, xy):
#def resize_window(title, xy):
#def get_screen_size():
