# -*- coding: iso_8859_1 -*-

import numpy as np

#----------------------------------------------------------------------------------------
#def mirror_x(images):
#def mirror_y(images):
#def rot_90(images):
#def rot_180(images):
#def rot_270(images):
#
#--- purpose ---
#these functions apply simple geometrical transforms to a list of input images
#1) mirror_x (resp. mirror_y) is a mirror symmetry around a vertical (resp. horizontal) line
#2) the 3 rotation functions correspond to clockwise rotations with rotation angles according to their function names
#----------------------------------------------------------------------------------------

def mirror_x(images):
	
	if len(images.shape)==2:
		images2 = images[::-1,:]
	elif len(images.shape)==3:
		images2 = images[:,::-1,:]

	return images2
	
def mirror_y(images):
	
	if len(images.shape)==2:
		images2 = images[:,::-1]
	elif len(images.shape)==3:
		images2 = images[:,:,::-1]

	return images2

def rot_90(images):
	
	if len(images.shape)==2:
		images2 = np.rot90(images)
	elif len(images.shape)==3:
		images2 = np.transpose(images,(1,2,0))
		images2 = np.rot90(images2)
		images2 = np.transpose(images,(2,0,1))

	return images2

def rot_180(images):
	
	if len(images.shape)==2:
		images2 = np.rot90(images,2)
	elif len(images.shape)==3:
		images2 = np.transpose(images,(1,2,0))
		images2 = np.rot90(images2,2)
		images2 = np.transpose(images,(2,0,1))

	return images2

def rot_270(images):
	
	if len(images.shape)==2:
		images2 = np.rot90(images,3)
	elif len(images.shape)==3:
		images2 = np.transpose(images,(1,2,0))
		images2 = np.rot90(images2,3)
		images2 = np.transpose(images,(2,0,1))

	return images2
