# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np

def coadd(images, mult, method='mean'):

	if method == 'mean':
		image_final = mult*astro.add_mean(images)
	elif method == 'median':
		image_final = mult*astro.add_median(images)
	elif method == 'sigma clipping':
		image_final = mult*astro.add_sigma_clipping(images,3.,1)	

	return image_final
	
def coadd_and_save(Imagelist, mult, coadded_Image, Config, method='mean', Headers={}):

	#--- loading images ---
	images = astro.get_imagedata(Imagelist)

	if method == 'mean':
		image_final = mult*astro.add_mean(images)
	elif method == 'median':
		image_final = mult*astro.add_median(images)
	elif method == 'sigma clipping':
		image_final = mult*astro.add_sigma_clipping(images,3.,1)
	
	#save image
	if astro.get_headervalues([Imagelist[0]], 'EXPOSURE')[0]!='':
		Exp = np.sum(np.array(astro.get_headervalues(Imagelist, 'EXPOSURE')))
	else:
		Exp = np.sum(np.array(astro.get_headervalues(Imagelist, 'EXPTIME')))
	Dateobs = sorted(astro.get_headervalues(Imagelist, 'DATE-OBS'))[0]
	Dateend = sorted(astro.get_headervalues(Imagelist, 'DATE-END'))[-1]
	headerdict = astro.create_headers(Config, [Imagelist[0]])[0]
	try:
		del headerdict['EXPTIME']
	except KeyError:
		pass
	headerdict.update(Headers)
	headerdict.update({'EXPOSURE':[Exp,'Exposure (s)'], 'DATE-OBS':[Dateobs,''],'DATE-END':[Dateend,'']})
	astro.save_imagelist(image_final, [headerdict], [coadded_Image])
	print
	print coadded_Image + ' saved'
		
	return image_final