# -*- coding: iso_8859_1 -*-
"""
Created on Thu Jan 27 09:24:47 2011
@author: Jerome Caron
"""

import numpy as np

def load_magfile(filename):

	#display file name
	file_path = filename.split('\\')
	file_core = file_path[len(file_path)-1]
	print "... loading %s ..." % file_core

	#temporal offset for date
	offset = 0.
	
	#open file and reads data
	f=open(filename, 'r')
	try:
		data = []
		flag = 0
		for line in f:
			if (1-flag):
				if line[0:6]=='POS -1':
					offset = float(line.split()[2])/2.
				if line[0] not in ['A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','\t','\n',';']:
					flag = 1
			if flag:
				datalist = line.split()
			
				#stores data in array
				x = []
				for dd in datalist:
					x.append(float(dd))
				data.append(x)
	finally:
		f.close()

	return np.array(data), offset

def load_file(filename):

	#display file name
	file_path = filename.split('\\')
	file_core = file_path[len(file_path)-1]
	print "... loading %s ..." % file_core
	
	#open file and reads data
	f=open(filename, 'r')
	try:
		data = []
		for line in f:
			if line[0] not in ['\t','\n']:
				datalist = line.split()
			
				#stores data in array
				x = []
				for dd in datalist:
					x.append(float(dd))
				data.append(x)
	finally:
		f.close()
		
	return np.array(data)

def calc_noise(mag):
	#this function estimates the noise of a magnitude curve. The principle is to smooth the curve with a moving window, and the difference between the 
	#initial curve and the smoothed curve is proportional to the noise
	#(other approaches are possible)
	if len(mag)<6:
		result = 'none'
	else:
		x = np.array(mag,dtype=np.float)
		y = x[2:-2] - (x[0:-4]+x[1:-3]+x[2:-2]+x[3:-1]+x[4:])/5.
		result = np.std(y,ddof=0) / np.sqrt(1.-1./5.)
		
	return result