# -*- coding: iso_8859_1 -*-

import numpy as np
import matplotlib.pyplot as plt
from scipy import optimize


def fit_givenperiod(alldata, period, T0, nb_harmo = 6):

	print "... least square fit with Fourier series, period = ",period 

	#fit parameters
	offsets = np.zeros((len(alldata)))
	an = np.ones((nb_harmo))
	bn = np.ones((nb_harmo))
	p = list(an) + list(bn) + list(offsets)
		
	#fit function
	def CDR(alldata, *p):
		#global T0
		result = np.array([])
		for i,dd in enumerate(alldata):
			arg = (dd[:,0]-T0)*2.*np.pi/period
			fit = p[i+2*nb_harmo]
			for j in range(nb_harmo):
				fit = fit + p[j]*np.cos(np.double(j+1)*arg) + p[j+nb_harmo]*np.sin(np.double(j+1)*arg)
			result = np.hstack((result,np.array(fit)))
		return result
		
	#re-organizing measurement data
	ydata = np.zeros((0.))
	for i,dd in enumerate(alldata):
		ydata = np.hstack((ydata,dd[:,1]))

	#fitting
	popt, pcov = optimize.curve_fit(CDR, alldata, ydata, p0=p)

	#calculating squared error
	return np.sum(((ydata - CDR(alldata, *popt))**2.).flatten())
