# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np
import scipy.fftpack as fft

def findintegershift_crosscorrelation(image1, image2, excluded = []):

	if len(excluded)!=0:
		value = astro.get_median(image1[0:40,0:40])
		for zone in excluded:
			image1[zone[0]:zone[1],zone[2]:zone[3]] = value

	#--- calculates cross-correlation between two images ---
	im1 = fft.fft2(image1)
	im2 = fft.fft2(image2)
	crosscorr = fft.ifft2(im1*np.ma.conjugate(im2))

	#--- finds the position of the max of the modulus of the cross-correlation ---
	modulus = fft.fftshift(np.abs(crosscorr))
	dx, dy = np.where(modulus==np.max(modulus.flatten()))
			
	#--- combines previous results
	dx3 = image1.shape[0]/2. - np.float(dx)
	dy3 = image1.shape[1]/2. - np.float(dy)
	return [dx3, dy3]
