# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np

def aperture_photometry(Imagelist, sizes, coord, method='normal'):
	
	#-------------------------
	if method == 'recenter':
		maxsize = 0
		for size in sizes:
			maxsize = max([maxsize, size[0]])
		#print maxsize
	#-------------------------
		
	#loop on images
	print
	mag_total = []
	for i in range(len(Imagelist)):

		#loads relevant image
		print 'Photometry on :',Imagelist[i].split('\\')[-1]
		image = astro.get_imagedata([Imagelist[i]], text_display=False)

		#loop on stars / asteroids
		mag_stars = []
		for j, xy in enumerate(coord[i]):

			mag_methods = []

			if (xy[0]==-1):
				for k in range(len(sizes)):		
					mag_methods.append(np.nan)
			else:
				#coordinates for object center
				x = np.round(xy[0])
				y = np.round(xy[1])
				dx = xy[0] - x
				dy = xy[1] - y
			
				#-------------------------
				if method == 'recenter':
					xnot = max(0,x-maxsize-3)
					xrange = min(image.shape[0],x+maxsize+4)
					ynot = max(0,y-maxsize-3)
					yrange = min(image.shape[1],y+maxsize+4)
					image2 = np.array(image)
					image2[xnot:xrange,ynot:yrange] = astro.translate_Bspline(image2[xnot:xrange,ynot:yrange],(-dx,-dy),3)
				#-------------------------
			
				#loop on apertures for photometry
				for k in range(len(sizes)):		

					#-------------------------
					if method == 'recenter':
						test = (x-sizes[k][0]-3<0)or(x+sizes[k][0]+4>image.shape[0])or(y-sizes[k][0]-3<0)or(y+sizes[k][0]+4>image.shape[1])
					else:
						test = (x-sizes[k][0]<0)or(x+sizes[k][0]+1>image.shape[0])or(y-sizes[k][0]<0)or(y+sizes[k][0]+1>image.shape[1])
					#-------------------------

					if 	test:
						print "aperture photometry on image", i+1, ": object", j+1, "too close from image border"
						mag_methods.append(np.nan)
					else:
						#selecting subimage
						xnot = max(0,x-sizes[k][2])
						xrange = min(image.shape[0],x+sizes[k][2]+1)
						ynot = max(0,y-sizes[k][2])
						yrange = min(image.shape[1],y+sizes[k][2]+1)

						subimage = image[xnot:xrange,ynot:yrange]
						subimage2 = image2[xnot:xrange,ynot:yrange]

						#aperture photometry
						grid = np.indices(subimage.shape)
						radius = (grid[0]-x+xnot)**2+(grid[1]-y+ynot)**2

						cond1 = radius<=sizes[k][0]**2
						cond2 = (radius>=sizes[k][1]**2)*(radius<=sizes[k][2]**2)

						#-------------------------
						if method == 'recenter':
							center = np.extract(cond1,subimage2)
						else:
							center = np.extract(cond1,subimage)
						#-------------------------
						crown = np.extract(cond2,subimage)

						#print np.where(radius==np.min(np.min(radius)))
						#print np.where(subimage==np.max(np.max(subimage)))
						#print np.where(subimage2==np.max(np.max(subimage2)))
						#raw_input("ok?")

						#------ magnitude calculation ------
						#floor = np.ma.median(np.array(crown,dtype=np.float))
						floor = astro.get_median(np.tile(np.array(crown,dtype=np.float),(1,1,1)))[0]
						intensity = np.sum(np.array(center,dtype=np.float)-floor)
						if intensity <= 0.:
							print "negative intensity on image", i+1, "for object", j+1
							mag_methods.append(np.nan)
						else:
							mag_methods.append(-2.5*np.log10(intensity))

			mag_stars.append(mag_methods)
		mag_total.append(mag_stars)
	return mag_total
