# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.cm as cm

def check_refstars(Imagelist, names_in, mag_in):

	nb_obj = len([i for i in names_in if (i[0]=='m')or(i[0]=='v')])
	nb_ref = len([i for i in names_in if (i[0]=='r')])

	plt.ion()
	ref_no = []

	#------ first check based on amplitude of magnitude variations ------
	for j in range(nb_ref):
		if np.sum(np.isnan(np.array(mag_in)[:,j+nb_obj,-1]))>5:
			print "Reference star nb",j+1,"could not be measured on some frame(s) so it is removed"
			ref_no.append(j)

	#------ second check based on user visual verification --------------
	if nb_ref-len(ref_no)>1:
		ans= ''
		while (ans!='yes'):

			#------ plot instrument differential magnitudes for reference stars ------
			fig = plt.figure()
			fig.canvas.set_window_title("Figure 1")
			plt.axes([0.1,0.1,0.7,0.8])

			mag = []
			name = []
			for j in range(nb_ref):
				if j not in ref_no:
					mag.append([mag_in[i][j+nb_obj][0] for i in range(len(Imagelist))])
					name.append('ref'+str(j+1))
			mag = np.array(mag, dtype = np.float)

			for j in range(len(mag)):
				plt.plot(mag[j] - np.mean(np.ma.masked_array(mag,np.isnan(mag)), axis=0),',-' ,c=cm.Set1(j*256/len(mag)), label=(name[j]))
			plt.legend(bbox_to_anchor=(1.02, 1.02), loc=2)
			plt.title("Differential magnitudes for REF stars")
			plt.grid()
			plt.draw()
			sx, sy = astro.get_window_size(u"C:\\WINDOWS\\system32\\cmd.exe")
			fx, fy = astro.get_window_position("Figure 1")
			astro.move_window("Figure 1", [sx, fy])
			astro.set_focus(u"C:\\WINDOWS\\System32\\cmd.exe")
			
			#------ question ---------------------------------------------------------
			print
			ans = raw_input("Are reference stars OK (answer must be 'yes' or 'no')?\n")
				
			if (ans=='no'):
				#------ then plot instrumental magnitudes ----------------------------
				plt.close()
				fig = plt.figure()
				fig.canvas.set_window_title("Figure 1")
				for j in range(len(mag)):
					plt.plot(mag[j],',-' ,label=(name[j]))
				plt.legend()
				plt.grid()
				plt.title("Instrumental magnitudes for REF stars")
				plt.draw()
				sx, sy = astro.get_window_size(u"C:\\WINDOWS\\system32\\cmd.exe")
				fx, fy = astro.get_window_position("Figure 1")
				astro.move_window("Figure 1", [sx, fy])
				astro.set_focus(u"C:\\WINDOWS\\System32\\cmd.exe")
				while 1:
					try:
						wrong = np.int(raw_input("which reference star is wrong ?\n"))
						break
					except:
						print "please enter an integer !"
				if (wrong>=1)and(wrong<=nb_ref):
					ref_no.append(wrong-1)

			plt.close()
		print

	return ref_no