# -*- coding: iso_8859_1 -*-

from astropython import astro
import numpy as np
import matplotlib.pyplot as plt
import matplotlib.cm as cm
import matplotlib.font_manager as fm
import os

def filter_magnitudes(good_Imagelist, names, obj_index, sizes, mag, ref_no):

	nb_ref = len([i for i in names if (i[0]=='r')])
	nb_mov = len([i for i in names if (i[0]=='m')])
	nb_vbl = len([i for i in names if (i[0]=='v')])
	nb_obj = nb_mov + nb_vbl

	prop = fm.FontProperties(size=11) 
	sx, sy = astro.get_window_size(u"C:\\WINDOWS\\system32\\cmd.exe")

	#------------------------------------------------------------------------------------	
	#		filtering magnitudes
	#------------------------------------------------------------------------------------	
	
	rej_data = []
	rej_sizes = []

	fig = plt.figure()
	fig.canvas.set_window_title(names[obj_index]) 
	plt.axes([0.08,0.05,0.7,0.85])
	for j in range(len(sizes)):
		mag_mov = [mag[k][obj_index][j] for k in range(len(good_Imagelist))]
		mag_ref = [np.sum([mag[k][nb_obj+p][j] for p in range(nb_ref) if p not in ref_no]) for k in range(len(good_Imagelist))]
		mag_dif = [mag_mov[k] - mag_ref[k]/(nb_ref-len(ref_no)) for k in range(len(good_Imagelist))]
		plt.plot(mag_dif - np.mean(np.ma.masked_array(mag_dif,np.isnan(mag_dif))), ',-', c=cm.Set1(j*256/len(sizes)), label=str(sizes[j]))
	plt.legend(prop=prop, bbox_to_anchor=(1.02, 1.), loc=2)
	plt.title(names[obj_index])
	plt.grid()
	fx, fy = astro.get_window_position(names[obj_index])
	astro.move_window(names[obj_index], [sx, fy])
	plt.draw()

	if (obj_index<nb_mov):
		print
		print '------ CHECKING DIFF MAGNITUDES FOR MOVING OBJECT',obj_index+1,'-----------------'
		print
		print 'You have now the possibility to reject some data. For instance, data corresponding to the asteroid crossing a star is detected because it gives smaller magnitudes (larger fluxes) for larger disk sizes.'
	elif (obj_index>=nb_mov):
		print
		print '------ CHECKING DIFF MAGNITUDES FOR VARIABLE STAR',obj_index+1-nb_mov,'-----------------'
		print
		print 'You have now the possibility to reject some data.'

	ans = raw_input('Do you want to do it (yes/no) ?')
	if ans=='yes':
		#---------------------------------------------------------------------
		if (len(sizes)>1):
			print
			print 'Rejection of photometry disks...'
			print 'if you want to reject the k-th specified disk, type k (for 1st disk write 1, 2nd disk write 2, etc)'
			print 'when finished, press Enter'
			while 1:
				try:
					val = int(raw_input('disk to be rejected:'))
					rej_sizes.append(val-1)
				except:
					break
		#---------------------------------------------------------------------
		print
		print 'Rejection of photometric data...'
		while 1:
			try:
				ans = int(raw_input('how many intervals do you want to reject ?'))
				break
			except:
				print "please enter an integer !"
		for j in range(ans):
			print
			print 'Interval',j+1
			while 1:
				try:
					mini = int(raw_input('first rejected data:'))
					break
				except:
					print "please enter an integer !"
			while 1:
				try:
					maxi = int(raw_input('last rejected data:'))
					break
				except:
					print "please enter an integer !"
			interval = range(min([mini,maxi]),max([mini, maxi])+1)
			rej_data = rej_data + interval
		#---------------------------------------------------------------------
	plt.close()
	print
	
	#------------------------------------------------------------------------------------	
	#		exporting results to output file
	#------------------------------------------------------------------------------------	

	return rej_sizes, rej_data