# -*- coding: iso_8859_1 -*-

import numpy as np
import itertools as it 

def calc_noise(mag):
	
	if len(mag)<6:
		result = 'none'
	else:
		x = np.array(mag,dtype=np.float)
		y = x[2:-2] - (x[0:-4]+x[1:-3]+x[2:-2]+x[3:-1]+x[4:])/5.
		result = np.std(y,ddof=0) / np.sqrt(1.-1./5.)
		
	return result

def best_magnitude(Imagelist, names, obj_index, sizes, mag, ref_no, nb=10, rejdata = [], rejsizes = []):
	
	nb_obs = len([i for i in names if (i[0]=='m')or(i[0]=='v')])  
	nb_ref = len([i for i in names if (i[0]=='r')])  
	nb_results = np.int(min([nb,len(sizes)*((2.**nb_ref)-1.)]))

	values = []
	for i in range(nb_ref):
		if i not in ref_no:
			values.append(i+1)
	values = np.array(values, dtype=np.int)
	
	mag_1 = []
	ref_1 = []
	sig_1 = []
	
	print "optimisation for ", names[obj_index]

	mag_2 = []
	ref_2 = []
	sig_2 = []
	for size in range(len(sizes)):						#loop on apertures
		if size not in rejsizes:
			print sizes[size]
			for i in range(len(values)): 						#loop on nb of reference stars chosen
				for j in list(it.combinations(values,i+1)):		#loop on possible combinations of these reference stars
						
					#print names[obj_index],sizes[size],"references stars",j

					mag_3 = []
					for pict in range(len(Imagelist)):						#loop on images
						if pict not in rejdata:
							mag_ref = 0.
							for k in range(len(j)):									#loop on reference stars
								mag_ref = mag_ref + mag[pict][nb_obs+j[k]-1][size] / len(j)			#mag_total[i][j][k] corresponds to object j  picture i method k
							mag_3.append(mag[pict][obj_index][size] - mag_ref)

					mag_2.append(mag_3)
					ref_2.append([size, j])
					sig_2.append(calc_noise(mag_3))		#here if there is a single np.nan in the data then sig_2 is also np.nan (due to calc_noise)
														#this trick helps to prevent that there is any np.nan in the data after optimisation
	#pick up best results
	ord = np.argsort(sig_2)

	for i in range(nb_results):
		mag_1.append(mag_2[ord[i]])

	for i in range(nb_results):
		ref_1.append(ref_2[ord[i]])

	for i in range(nb_results):
		sig_1.append(sig_2[ord[i]])
	
	print
	return ref_1, mag_1, sig_1